//+------------------------------------------------------------------+
//|                                                      4052012.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//-------    --------------------------------
extern string _P_Expert = "----------  ";
extern bool CurSymbolOnly = false; //   
extern double sl=40;     // SL   
extern double tp =100;      //    
extern int mn     = 140512;// 
extern bool UseSound = True; //      
extern string NameFileSound = "manycoin.wav"; //   
extern int Slippage = 3; //  
extern int NumberOfTry = 5; //    
extern double Lots =0.2; //  
extern int MaxRisk=5;          //  ,  
extern bool UseTrailing      = True;        //  
extern bool ProfitTrailing   = True;        //   
extern int  TrailingStopBuy  = 50;          //   
extern int  TrailingStopSell = 50;          //   
extern int  TrailingStep     = 5;           //  
   
                       
//-------    --------------------------------------
color clCloseBuy = Red; //    
color clCloseSell = Red; //    
color clOpenBuy = Blue; //    
color clOpenSell = Blue; //    
color clModifyBuy = Green;
color clModifySell = Green;
int CurProfit;
double Lots_New;      //     
bool Lot = true;       //   
bool   gbDisabled   = False;           //   
//-------    -------------------------------------------
#include <stdlib.mqh>
#include <WinUser32.mqh>


//+------------------------------------------------------------------+
//| expert initialization function                                 |
//+------------------------------------------------------------------+
void init() { if (IsTesting()) Comment(""); }

//+----------------------------------------------------------------------------+
//| expert deinitialization function |
//+----------------------------------------------------------------------------+
void deinit() { if (IsTesting()) Comment(""); }


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {

//--------------------------------------------------------------- 1--

  
 bool b,s;
   int tip;
   for (int j=0; j<OrdersTotal(); j++)
   {  if (OrderSelect(j,SELECT_BY_POS,MODE_TRADES)==true)
      {  if (mn==OrderMagicNumber() && OrderSymbol()==Symbol())
         {
            tip = OrderType();
            if (tip==OP_BUY ) b=1;
            if (tip==OP_SELL) s=1;
         }  
      }  
   
 if (b>0||s>0)
       { if (UseTrailing) TrailingPositions("",-1, mn); } 
 
 }
 
 
//--------------------------------------------------------------- 2--
 
 
 if (ExistPositions("",-1,-1,0)==False )

 { double nz= GetExtremumZZBar(),
          ncl= NumberOfBarCloseLastPos(mn);
   if (  nz<  ncl)
 
   double pp1 = iClose(NULL, 0 , 1);
   double ZZ2 = GetExtremumZZPrice("", 0, 1, 12, 5,3);
   double ZZ1 = GetExtremumZZPrice("", 0, 0, 12, 5,3);
//--------------------------------------------------------------- 3 --


if ( Lot(sl)==true)
{Alert(" " ,  Lots_New);}
 
//--------------------------------------------------------------- 4 --
   double pa=MarketInfo(Symbol(), MODE_ASK);
   double pb=MarketInfo(Symbol(), MODE_BID);
   double po=MarketInfo(Symbol(), MODE_POINT);
   double TPB= NormalizeDouble(pa+tp*po, Digits);//    buy
   double SLB= NormalizeDouble(pa-sl*po, Digits);//  SL  buy
   double TPS= NormalizeDouble(pa-tp*po, Digits);//    sell
   double SLS= NormalizeDouble(pa+sl*po, Digits);//  SL  sell

   
   
if (ZZ2< pp1 )

    { 
    OpenPosition ("", OP_BUY, Lots_New,SLB ,TPB , mn);}

if (pp1 < ZZ2)
    
    {OpenPosition("", OP_SELL, Lots_New, SLS,TPS , mn);}
}
//--------------------------------------------------------------- 5 --
  
   return(0);
  }
//+------------------------------------------------------------------+



//--------------------------------------------------------------------
// Lot.mqh
// 
//--------------------------------------------------------------- 1 --
//    .
//  :
// double Lots_New -      ()
// double Lots     -   ,  .
// double  MaksRisk  -  
//  :
// true  -      
// false -       
//--------------------------------------------------------------- 2 --
bool Lot(int sl)                               //  -
  {
   string Symb   =Symbol();                    //  .
   double One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);//. 1 
   double Min_Lot=MarketInfo(Symb,MODE_MINLOT);// . . 
   double Max_Lot =MarketInfo(Symbol(),MODE_MAXLOT);
   double Step   =MarketInfo(Symb,MODE_LOTSTEP);//  
   double Free   =AccountFreeMargin();         //  
   double LotVal =MarketInfo(Symbol(),MODE_TICKVALUE);// 1   1 
   

//--------------------------------------------------------------- 3 --
   if (Lots > 0)                                 //   ..
     {                                         // .. 
      double Money=Lots*One_Lot;               //  
      if(Money<=AccountFreeMargin())           //  ..
         Lots_New=Lots;                        // .. 
      else                                     //   ..
         Lots_New=MathFloor(Free/One_Lot/Step)*Step;//  
     }
//--------------------------------------------------------------- 4 --
  else                                        //    
     {                                         //    
                                               // . .:
                                               
      Lots_New =MathFloor((Free*MaxRisk/100)/(sl*LotVal)/Step)*Step;
      if(Lots_New<Min_Lot) Lots_New=Min_Lot;
      if(Lots_New>Max_Lot) Lots_New=Max_Lot;
      Print ("Lot_New  - Lots = ",Lots_New, "  = ",sl, "Point  = ",Point);
     }
//--------------------------------------------------------------- 5 --
   if (Lots_New < Min_Lot)                     //   ..
      Lots_New=Min_Lot;                        // ..  
   if (Lots_New*One_Lot > AccountFreeMargin()) //   ..
     {                                         // .. . :(
      Print ("     .  Lots_New = ",Lots_New, " AccountFreeMargin() = ", AccountFreeMargin());  // ..
      return(false);                           // ..  
     }
   return(true);                               //   . -
  }
//--------------------------------------------------------------- 6 --



 
 //+-----------------------------------------------------------------------1-----+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 06.03.2008                                                     |
//|   :                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )           |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();
 
  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) return(True);
            }
          }
        }
      }
    }
  }
  return(False);
}
 
 //--------------------------------------------------------------- 2 --
 
 
 //+------------------------------------------------------------------1--------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 07.10.2006                                                     |
//|   :      .                    |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    tf -                   (      0     -  )              |
//|    ne -             (      0     - )               |
//|    dp - ExtDepth                                                           |
//|    dv - ExtDeviation                                                       |
//|    bs - ExtBackstep                                                        |
//+----------------------------------------------------------------------------+
double GetExtremumZZPrice(string sy="", int tf=0, int ne=0, int dp=12, int dv=5, int bs=3) {
  if (sy=="" || sy=="0") sy=Symbol();
  double zz;
  int    i, k=iBars(sy, tf), ke=0;

  for (i=1; i<k; i++) {
    zz=iCustom(sy, tf, "ZigZag", dp, dv, bs, 0, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(zz);
    }
  }
  Print("GetExtremumZZPrice():    ",ne,"  ");
  return(0);
}
  //+---------------------------------------------------------------------2----+
 
 
 
 
 ///|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|    : 13.06.2007                                                      |
//|   :  .      .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     ("" -  )                   |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//+----------------------------------------------------------------------------+
void OpenPosition(string sy, int op, double ll, double sl, double tp, int mn=0) {
  color  clOpen;
  double pp;
  int    err, ticket;
 
  if (sy=="") sy=Symbol();
  if (op==OP_BUY) {
    pp=MarketInfo(sy, MODE_ASK); clOpen=clOpenBuy;
  } else {
    pp=MarketInfo(sy, MODE_BID); clOpen=clOpenSell;
  }
  ticket=OrderSend(sy, op, ll, NormalizeDouble(pp,Digits), Slippage, sl, tp, "", mn, 0, clOpen);
  if (ticket<0) {
    err=GetLastError();
    Print("Error(",err,") open ",GetNameOP(op),": ",ErrorDescription(err));
    Print("Ask=",Ask," Bid=",Bid," sy=",sy," ll=",ll,
          " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
  }
}


//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}



//+----------------------------------------------------------------------------+
//|                                           |
//|  :                                                                |
//|    sy -     ("" -  )                   |
//|    op -                    (-1 -  )                    |
//|    mn - MagicNumber                (-1 -  )                      |
//+----------------------------------------------------------------------------+
void TrailingPositions(string sy="", int op=-1, int mn=-1) {
  double p, pp;
  int    i, k=OrdersTotal();

  if (sy=="") sy=Symbol();
  p=MarketInfo(sy, MODE_POINT);
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          if (OrderType()==OP_BUY) {
            pp=MarketInfo(sy, MODE_BID);
            if (!ProfitTrailing || (pp-OrderOpenPrice())>TrailingStopBuy*p) {
              if (OrderStopLoss()<pp-(TrailingStopBuy+TrailingStep-1)*p) {
                ModifyOrder( -1, pp-TrailingStopBuy*p, 0, clModifyBuy);
              }
            }
          }
          if (OrderType()==OP_SELL) {
            pp=MarketInfo(sy, MODE_ASK);
            if (!ProfitTrailing || OrderOpenPrice()-pp>TrailingStopSell*p) {
              if (OrderStopLoss()>pp+(TrailingStopSell+TrailingStep-1)*p || OrderStopLoss()==0) {
                ModifyOrder( -1, pp+TrailingStopSell*p, 0, clModifySell);
              }
            }
          }
        }
      }
    }
  }
}


//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    cl -                                               |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, color cl=CLR_NONE) {
  bool   fm;
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;
 
  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);
 
  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, 0, cl);
      if (fm) {
        if (UseSound) PlaySound(NameFileSound); break;
      } else {
        er=GetLastError();
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}

//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 07.10.2006                                                     |
//|   :        .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    tf -                   (      0     -  )              |
//|    ne -             (      0     - )               |
//|    dp - ExtDepth                                                           |
//|    dv - ExtDeviation                                                       |
//|    bs - ExtBackstep                                                        |
//+----------------------------------------------------------------------------+
int GetExtremumZZBar(string sy="", int tf=0, int ne=0, int dp=12, int dv=5, int bc=3) {
  if (sy=="" || sy=="0") sy=Symbol();
  double zz;
  int    i, k=iBars(sy, tf), ke=0;

  for (i=0; i<k; i++) {
    zz=iCustom(sy, tf, "ZigZag", dp, dv, bc, 0, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(i);
    }
  }
  Print("GetExtremumZZBar():    ",ne,"  ");
  return(-1);
}


//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :        -1.       |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""  NULL -  )          |
//|    tf -                   (    0       -  )       |
//|    op -                    (   -1       -  )           |
//|    mn - MagicNumber                (   -1       -  )             |
//+----------------------------------------------------------------------------+
int NumberOfBarCloseLastPos(string sy="0", int tf=0, int op=-1, int mn=-1) {
  datetime t;
  int      i, k=OrdersHistoryTotal();

  if (sy=="" || sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sy) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (t<OrderCloseTime()) t=OrderCloseTime();
            }
          }
        }
      }
    }
  }
  return(iBarShift(sy, tf, t, True));
}